'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SYSTEM_CHALLENGES_COUNT = exports.PAYOUT_PERIOD_UNIT = exports.STORAGE_PERIOD_UNIT = exports.DAY = exports.ONE = exports.PAYOUT_PERIOD_IN_SECONDS = exports.ATLAS3_STORAGE_LIMIT = exports.ATLAS2_STORAGE_LIMIT = exports.ATLAS1_STORAGE_LIMIT = exports.APOLLO_DEPOSIT = exports.ATLAS3_STAKE = exports.ATLAS2_STAKE = exports.ATLAS1_STAKE = exports.ROLE_CODES = exports.APOLLO = exports.HERMES = exports.ATLAS = exports.MIN_BLOCK_TIME = undefined;

var _web3_tools = require('./utils/web3_tools');

var _bn = require('bn.js');

var _bn2 = _interopRequireDefault(_bn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright: Ambrosus Technologies GmbH
Email: tech@ambrosus.com

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var MIN_BLOCK_TIME = exports.MIN_BLOCK_TIME = 5;

var ATLAS = exports.ATLAS = 1;
var HERMES = exports.HERMES = 2;
var APOLLO = exports.APOLLO = 3;
var ROLE_CODES = exports.ROLE_CODES = { ATLAS: ATLAS, HERMES: HERMES, APOLLO: APOLLO };

var ATLAS1_STAKE = exports.ATLAS1_STAKE = _web3_tools.utils.toWei(new _bn2.default(10000));
var ATLAS2_STAKE = exports.ATLAS2_STAKE = _web3_tools.utils.toWei(new _bn2.default(30000));
var ATLAS3_STAKE = exports.ATLAS3_STAKE = _web3_tools.utils.toWei(new _bn2.default(75000));
var APOLLO_DEPOSIT = exports.APOLLO_DEPOSIT = _web3_tools.utils.toWei(new _bn2.default(250000));

var ATLAS1_STORAGE_LIMIT = exports.ATLAS1_STORAGE_LIMIT = 100000;
var ATLAS2_STORAGE_LIMIT = exports.ATLAS2_STORAGE_LIMIT = 400000;
var ATLAS3_STORAGE_LIMIT = exports.ATLAS3_STORAGE_LIMIT = 1000000;

var PAYOUT_PERIOD_IN_SECONDS = exports.PAYOUT_PERIOD_IN_SECONDS = 28 * 24 * 60 * 60;

var ONE = exports.ONE = new _bn2.default(1);
var DAY = exports.DAY = 60 * 60 * 24;

var STORAGE_PERIOD_UNIT = exports.STORAGE_PERIOD_UNIT = 364 * DAY;
var PAYOUT_PERIOD_UNIT = exports.PAYOUT_PERIOD_UNIT = 28 * DAY;

var SYSTEM_CHALLENGES_COUNT = exports.SYSTEM_CHALLENGES_COUNT = 7;