'use strict';

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _web3_tools = require('../utils/web3_tools');

var _whitelist = require('./whitelist');

var _whitelist2 = _interopRequireDefault(_whitelist);

var _deploy = require('./deploy');

var _deploy2 = _interopRequireDefault(_deploy);

var _onboard = require('./onboard');

var _onboard2 = _interopRequireDefault(_onboard);

var _task_list = require('./base/task_list');

var _task_list2 = _interopRequireDefault(_task_list);

var _upload = require('./upload');

var _upload2 = _interopRequireDefault(_upload);

var _contract_manager = require('../wrappers/contract_manager');

var _contract_manager2 = _interopRequireDefault(_contract_manager);

var _config = require('../../config/config');

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright: Ambrosus Technologies GmbH
Email: tech@ambrosus.com

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var runTask = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var web3, nodeAddress, contractManager, list, args;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _web3_tools.createWeb3)();

          case 2:
            web3 = _context.sent;
            nodeAddress = web3.eth.accounts.privateKeyToAccount(_config2.default.nodePrivateKey).address;
            contractManager = new _contract_manager2.default(web3, _config2.default.headContractAddress, nodeAddress);
            list = new _task_list2.default();
            args = process.argv.slice(2);

            list.add('deploy', new _deploy2.default(web3, nodeAddress));
            list.add('onboard', new _onboard2.default(web3, contractManager));
            list.add('whitelist', new _whitelist2.default(web3, contractManager));
            list.add('upload', new _upload2.default(contractManager));
            _context.next = 13;
            return list.run(args[0], args.slice(1));

          case 13:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function runTask() {
    return _ref.apply(this, arguments);
  };
}();

runTask().catch(function (error) {
  console.error(error);
  process.exit(1);
});