'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _web3_tools = require('../utils/web3_tools');

var _contract_jsons = require('../contract_jsons');

var _contract_jsons2 = _interopRequireDefault(_contract_jsons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/** @abstract */
/*
Copyright: Ambrosus Technologies GmbH
Email: tech@ambrosus.com

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at https://mozilla.org/MPL/2.0/.

This Source Code Form is “Incompatible With Secondary Licenses”, as defined by the Mozilla Public License, v. 2.0.
*/

var ContractWrapper = function () {
  function ContractWrapper(headWrapper, web3, defaultAddress) {
    (0, _classCallCheck3.default)(this, ContractWrapper);

    this.headWrapper = headWrapper;
    this.web3 = web3;
    this.defaultAddress = defaultAddress;
  }

  (0, _createClass3.default)(ContractWrapper, [{
    key: 'contract',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
        var contractAddress;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.headWrapper.contractAddressByName(this.getContractName);

              case 2:
                contractAddress = _context.sent;
                return _context.abrupt('return', (0, _web3_tools.loadContract)(this.web3, _contract_jsons2.default[this.getContractName].abi, contractAddress));

              case 4:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function contract() {
        return _ref.apply(this, arguments);
      }

      return contract;
    }()
  }, {
    key: 'setDefaultAddress',
    value: function setDefaultAddress(defaultAddress) {
      this.defaultAddress = defaultAddress;
    }
  }, {
    key: 'getContractName',
    get: function get() {
      throw new Error('Abstract method getContractName needs to be overridden');
    }
  }]);
  return ContractWrapper;
}();

exports.default = ContractWrapper;